(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/fire/storage'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('file-upload-firestorage', ['exports', '@angular/core', '@angular/fire/storage', '@angular/common'], factory) :
    (global = global || self, factory(global['file-upload-firestorage'] = {}, global.ng.core, global.ng.fire.storage, global.ng.common));
}(this, function (exports, core, storage, common) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var FILE_SIZE_UNITS = ['B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
    /** @type {?} */
    var FILE_SIZE_UNITS_LONG = ['Bytes', 'Kilobytes', 'Megabytes', 'Gigabytes', 'Pettabytes', 'Exabytes', 'Zettabytes', 'Yottabytes'];
    var FileSizePipe = /** @class */ (function () {
        function FileSizePipe() {
        }
        /**
         * @param {?} sizeInBytes
         * @param {?=} longForm
         * @return {?}
         */
        FileSizePipe.prototype.transform = /**
         * @param {?} sizeInBytes
         * @param {?=} longForm
         * @return {?}
         */
        function (sizeInBytes, longForm) {
            /** @type {?} */
            var units = longForm
                ? FILE_SIZE_UNITS_LONG
                : FILE_SIZE_UNITS;
            /** @type {?} */
            var power = Math.round(Math.log(sizeInBytes) / Math.log(1024));
            power = Math.min(power, units.length - 1);
            /** @type {?} */
            var size = sizeInBytes / Math.pow(1024, power);
            // size in new units
            /** @type {?} */
            var formattedSize = Math.round(size * 100) / 100;
            // keep up to 2 decimals
            /** @type {?} */
            var unit = units[power];
            return size ? formattedSize + " " + unit : '0';
        };
        FileSizePipe.decorators = [
            { type: core.Pipe, args: [{
                        name: 'fileSize'
                    },] }
        ];
        return FileSizePipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DropZoneDirective = /** @class */ (function () {
        function DropZoneDirective() {
            this.dropped = new core.EventEmitter();
            this.hovered = new core.EventEmitter();
        }
        /**
         * @param {?} $event
         * @return {?}
         */
        DropZoneDirective.prototype.onDrop = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            $event.preventDefault();
            this.dropped.emit($event.dataTransfer.files);
            this.hovered.emit(false);
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        DropZoneDirective.prototype.onDragOver = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            $event.preventDefault();
            this.hovered.emit(true);
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        DropZoneDirective.prototype.onDragLeave = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            $event.preventDefault();
            this.hovered.emit(false);
        };
        DropZoneDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[dropZone]'
                    },] }
        ];
        /** @nocollapse */
        DropZoneDirective.ctorParameters = function () { return []; };
        DropZoneDirective.propDecorators = {
            dropped: [{ type: core.Output }],
            hovered: [{ type: core.Output }],
            onDrop: [{ type: core.HostListener, args: ['drop', ['$event'],] }],
            onDragOver: [{ type: core.HostListener, args: ['dragover', ['$event'],] }],
            onDragLeave: [{ type: core.HostListener, args: ['dragleave', ['$event'],] }]
        };
        return DropZoneDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FileUploadFirestorageService = /** @class */ (function () {
        function FileUploadFirestorageService() {
        }
        FileUploadFirestorageService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        FileUploadFirestorageService.ctorParameters = function () { return []; };
        /** @nocollapse */ FileUploadFirestorageService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function FileUploadFirestorageService_Factory() { return new FileUploadFirestorageService(); }, token: FileUploadFirestorageService, providedIn: "root" });
        return FileUploadFirestorageService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FileUploadFirestorageComponent = /** @class */ (function () {
        function FileUploadFirestorageComponent(storage) {
            this.storage = storage;
            this.res = new core.EventEmitter();
        }
        /**
         * @param {?} event
         * @return {?}
         */
        FileUploadFirestorageComponent.prototype.toggleHover = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            this.isHovering = event;
        };
        /**
         * @param {?} event
         * @return {?}
         */
        FileUploadFirestorageComponent.prototype.startUpload = /**
         * @param {?} event
         * @return {?}
         */
        function (event) {
            var _this = this;
            // The File object
            /** @type {?} */
            var file = event.item(0);
            // Client-side validation example
            if (this.onlyType) {
                if (!(this.onlyType.includes(file.type.split('/')[0]))) {
                    console.error('unsupported file type: ', file.type.split('/')[0]);
                    return;
                }
            }
            if (this.maxSize) {
                if (file.size >= this.maxSize) {
                    console.error('unsupported size file. Its too heavy ', file.size);
                    return;
                }
            }
            if (!this.onlyType && (file.type.split('/')[0] !== 'image' && file.type.split('/')[0] !== 'pdf')) {
                console.error('unsupported file type: ', file.type.split('/')[0]);
                return;
            }
            // The storage path
            /** @type {?} */
            var path = this.storagePath + "/" + new Date().getTime() + "_" + file.name;
            // // Totally optional metadata
            // const customMetadata = { app: 'Murbinas Painting Uploader' };
            // The main task
            this.task = this.storage.upload(path, file);
            // Progress monitoring
            this.percentage = this.task.percentageChanges();
            this.snapshot = this.task.snapshotChanges();
            // The file's download URL
            this.task.then((/**
             * @param {?} d
             * @return {?}
             */
            function (d) {
                d.ref.getDownloadURL().then((/**
                 * @param {?} url
                 * @return {?}
                 */
                function (url) {
                    _this.snapshot = null;
                    _this.percentage = null;
                    _this.res.emit({ thumbnail: url, locationPath: d.ref.fullPath.split('/').pop() });
                }));
            }));
        };
        // Determines if the upload task is active
        // Determines if the upload task is active
        /**
         * @param {?} snapshot
         * @return {?}
         */
        FileUploadFirestorageComponent.prototype.isActive = 
        // Determines if the upload task is active
        /**
         * @param {?} snapshot
         * @return {?}
         */
        function (snapshot) {
            return snapshot.state === 'running' && snapshot.bytesTransferred < snapshot.totalBytes;
        };
        /**
         * @return {?}
         */
        FileUploadFirestorageComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        FileUploadFirestorageComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'lib-file-upload-firestorage',
                        template: "\n  <div class=\"dropzone\" dropZone (hovered)=\"toggleHover($event)\" (dropped)=\"startUpload($event)\"\n  [class.hovering]=\"isHovering\">\n\n\n\n  <h3> File Drop Zone </h3>\n  <h6> Drop your file here </h6>\n\n  <div class=\"file\">\n    <label class=\"file-label\">\n      <input class=\"file-input\" type=\"file\" (change)=\"startUpload($event.target.files)\">\n      <span class=\"file-cta\">\n        <span class=\"file-icon\">\n          <i class=\"fa fa-upload\"></i>\n        </span>\n        <span class=\"file-label\">\n          or <strong>click here</strong> to choose a file\u2026\n        </span>\n      </span>\n    </label>\n  </div>\n</div>\n\n<div *ngIf=\"(percentage | async) as pct\">\n\n  <progress class=\"progress is-info\" [value]=\"pct || 0\" max=\"100\">\n  </progress>\n\n  {{ pct | number }}%\n\n</div>\n\n<div *ngIf=\"(snapshot | async) as snap\">\n  {{ snap.bytesTransferred | fileSize }} of {{ snap.totalBytes | fileSize }}\n\n  <button (click)=\"task.pause()\" class=\"button is-warning\" [disabled]=\"!isActive(snap)\">Pause</button>\n  <button (click)=\"task.cancel()\" class=\"button is-danger\" [disabled]=\"!isActive(snap)\">Cancel</button>\n  <button (click)=\"task.resume()\" class=\"button is-info\" [disabled]=\"!(snap?.state === 'paused')\">Resume</button>\n\n</div>\n  ",
                        styles: ["\n    .dropzone {\n      display: flex;\n      align-items: center;\n      justify-content: center;\n      flex-direction: column;\n      height: 100%;\n      min-height: 100px;\n      border: 2px dashed #f16624;\n      border-radius: 5px;\n      background: white;\n      margin: 0;\n      cursor:pointer;\n      padding: .5rem;\n    }\n\n    .dropzone:hover {\n      border: 2px solid #f16624;\n      color: #dadada !important;\n    }\n\n    .dropzone .file input.file-input{\n        width: 0;\n    }\n\n    progress::-webkit-progress-value {\n        transition: width 0.1s ease;\n    }\n  "]
                    }] }
        ];
        /** @nocollapse */
        FileUploadFirestorageComponent.ctorParameters = function () { return [
            { type: storage.AngularFireStorage }
        ]; };
        FileUploadFirestorageComponent.propDecorators = {
            res: [{ type: core.Output }],
            storagePath: [{ type: core.Input }],
            maxSize: [{ type: core.Input }],
            onlyType: [{ type: core.Input }]
        };
        return FileUploadFirestorageComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FileUploadFirestorageModule = /** @class */ (function () {
        function FileUploadFirestorageModule() {
        }
        FileUploadFirestorageModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            FileSizePipe,
                            DropZoneDirective,
                            FileUploadFirestorageComponent,
                        ],
                        imports: [
                            storage.AngularFireStorageModule,
                            common.CommonModule
                        ],
                        exports: [
                            FileSizePipe,
                            DropZoneDirective,
                            FileUploadFirestorageComponent,
                        ],
                        schemas: [core.CUSTOM_ELEMENTS_SCHEMA]
                    },] }
        ];
        return FileUploadFirestorageModule;
    }());

    exports.DropZoneDirective = DropZoneDirective;
    exports.FileSizePipe = FileSizePipe;
    exports.FileUploadFirestorageComponent = FileUploadFirestorageComponent;
    exports.FileUploadFirestorageModule = FileUploadFirestorageModule;
    exports.FileUploadFirestorageService = FileUploadFirestorageService;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=file-upload-firestorage.umd.js.map
